package rocks.zipcode;

import java.io.*;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author leon on 16/11/2018.
 */
public class Document implements DocumentInterface {

    private final File file;

    public Document(String fileName) throws IOException {
        this(new File(fileName));
    }

    public Document(File file) throws IOException {
        this.file = file;
    }

    @Override
    public void write(String contentToBeWritten) {
        BufferedWriter bw = null;
        try {
            bw = new BufferedWriter(new FileWriter(file, false));
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            bw.write(contentToBeWritten);
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            try {
                bw.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void write(Integer lineNumber, String valueToBeWritten) {
            String result = "";
            String[] input = this.read().split("\n");
            input[lineNumber]=valueToBeWritten;
            for (String str: input) {
                result += str;
                result += "\n";
            }
            this.write(result);
    }

    @Override
    public String read(Integer lineNumber) {
        return this.toList().get(lineNumber);
    }

    @Override
    public String read() {
        String result ="";
        try {
            BufferedReader br = new BufferedReader(new FileReader(file));
            String str =br.readLine();
            while (str  != null){
                result+= str;
                str = br.readLine();
                result += "\n";
            }
            result= result.substring(0,result.length()-1);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return result;
    }

    @Override
    public void replaceAll(String stringToReplace, String replacementString) {
        String input = this.read().replaceAll(stringToReplace, replacementString);
        this.write(input);
    }

    @Override
    public void overWrite(String content) {
        this.write(content);
    }

    public List<String> toList() {
       return new ArrayList<>(Arrays.asList(this.read().split("\n")));
    }

    @Override
    public File getFile() {
       return this.file;
    }

    @Override
    public String toString() {
        return this.getFile() + "{" + this.read() +"}";
    }
}
